# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union

from pydantic import BaseModel, Field, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class CreateBillingMeterEventRequest(BaseModel):
  """
    CreateBillingMeterEventRequest
    """

  # noqa: E501
  event_name: StrictStr = Field(
    description='The name of the meter event. Corresponds with the event_name field on a meter.'
  )
  payload: Union[str, Any] = Field(
    description=
    'The payload of the event. This must contain the fields corresponding to a meter’s event_payload_customer_mapping_key (default is customer_id) and event_payload_value_key (default is value). '
  )
  identifier: Optional[StrictStr] = Field(
    default=None,
    description=
    'A unique identifier for the event. If not provided, one will be generated. We recommend using a globally unique identifier for this.'
  )
  event_datetime: Optional[datetime] = Field(default=None, description='The time of the event.')
  __properties: ClassVar[List[str]] = ['event_name', 'payload', 'identifier', 'event_datetime']

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of CreateBillingMeterEventRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of CreateBillingMeterEventRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'event_name': obj.get('event_name'),
        'payload': obj.get('payload'),
        'identifier': obj.get('identifier'),
        'event_datetime': obj.get('event_datetime')
      }
    )
    return _obj
