# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Union

from pydantic import BaseModel, Field, StrictBool, StrictStr

try:
  from typing import Self
except ImportError:
  from typing_extensions import Self


class UpdateInvoiceRequest(BaseModel):
  """
    UpdateInvoiceRequest
    """

  # noqa: E501
  payment_method_id: Optional[StrictStr] = None
  description: Optional[StrictStr] = Field(
    default='Manual creation of invoice', description='Description for newly created invoice'
  )
  coupon_id: Optional[StrictStr] = None
  custom_fields: Optional[Union[str, Any]] = None
  email_invoice_on_finalization: Optional[StrictBool] = None
  __properties: ClassVar[List[str]] = [
    'payment_method_id', 'description', 'coupon_id', 'custom_fields',
    'email_invoice_on_finalization'
  ]

  model_config = {'populate_by_name': True, 'validate_assignment': True}

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.model_dump(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> Self:
    """Create an instance of UpdateInvoiceRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self) -> Dict[str, Any]:
    """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
    _dict = self.model_dump(
      by_alias=True,
      exclude={},
      exclude_none=True,
    )
    # set to None if payment_method_id (nullable) is None
    # and model_fields_set contains the field
    if self.payment_method_id is None and 'payment_method_id' in self.model_fields_set:
      _dict['payment_method_id'] = None

    # set to None if coupon_id (nullable) is None
    # and model_fields_set contains the field
    if self.coupon_id is None and 'coupon_id' in self.model_fields_set:
      _dict['coupon_id'] = None

    # set to None if custom_fields (nullable) is None
    # and model_fields_set contains the field
    if self.custom_fields is None and 'custom_fields' in self.model_fields_set:
      _dict['custom_fields'] = None

    # set to None if email_invoice_on_finalization (nullable) is None
    # and model_fields_set contains the field
    if self.email_invoice_on_finalization is None and 'email_invoice_on_finalization' in self.model_fields_set:
      _dict['email_invoice_on_finalization'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: Dict) -> Self:
    """Create an instance of UpdateInvoiceRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return cls.model_validate(obj)

    _obj = cls.model_validate(
      {
        'payment_method_id': obj.get('payment_method_id'),
        'description':
          obj.get('description')
          if obj.get('description') is not None else 'Manual creation of invoice',
        'coupon_id': obj.get('coupon_id'),
        'custom_fields': obj.get('custom_fields'),
        'email_invoice_on_finalization': obj.get('email_invoice_on_finalization')
      }
    )
    return _obj
